#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "pacres.h"
#include "highscores.h"


void InitHighScores(void)
{
	FILE *fp;
	int y;

	// If there is a highscore data file then open it and read the scores
	if ((fp=fopen("HIGHSCORE.DAT","r")) !=NULL)
	{
		for(y=0;y<10;y++)
		{
			fread(&HighScores[y],sizeof(HighScores[y]),1,fp);
		}
		fclose(fp);
	}

	// No highscore file so load the default scores
	else
	{
		strcpy(HighScores[0].NAME, "Les Farrell");
		HighScores[0].SCORE=5000;

		strcpy(HighScores[1].NAME, "Jenny Neve");
		HighScores[1].SCORE=4510;

		strcpy(HighScores[2].NAME, "Charmed");
		HighScores[2].SCORE=4050;

		strcpy(HighScores[3].NAME, "Legolas");
		HighScores[3].SCORE=3940;

		strcpy(HighScores[4].NAME, "Dap");
		HighScores[4].SCORE=3730;

		strcpy(HighScores[5].NAME, "Callum");
		HighScores[5].SCORE=3030;

		strcpy(HighScores[6].NAME, "Sam");
		HighScores[6].SCORE=2080;

		strcpy(HighScores[7].NAME, "Andy");
		HighScores[7].SCORE=1090;

		strcpy(HighScores[8].NAME, "Paul");
		HighScores[8].SCORE=900;

		strcpy(HighScores[9].NAME, "Kaz");
		HighScores[9].SCORE=400;
	}

	// Store the highest score
	HIGHSCORE=HighScores[0].SCORE;
}


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// Do a simple bubble sort on the scores.
// So we have the proper rating order in the table!
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
void SortScores(void)
{
	FILE *fp;
	int i,j,y;
	struct HIGH_SCORE	TempScore;

	for(i=0;i<10-1;i++)
	{
		for(j=i+1;j<10;j++)
		{
			if(HighScores[j].SCORE > HighScores[i].SCORE)
			{
				TempScore.SCORE=HighScores[j].SCORE;
				strcpy(TempScore.NAME,HighScores[j].NAME);

				HighScores[j].SCORE = HighScores[i].SCORE;
				strcpy(HighScores[j].NAME, HighScores[i].NAME);

				HighScores[i].SCORE=TempScore.SCORE;
				strcpy(HighScores[i].NAME,TempScore.NAME);
			}
		}
	}

	// Save the newly sorted highscore table to file!
	if ((fp=fopen("HIGHSCORE.DAT","w")) != NULL)
	{
		for(y=0;y<10;y++)
		{
			fwrite(&HighScores[y],sizeof(HighScores[y]),1,fp);
		}
		fclose(fp);
	}

	// Store the highest score
	HIGHSCORE=HighScores[0].SCORE;
}


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// Is the passed score going to make it into the table?
// i.e, Is the score higher than the last one in the table?
// Returns:
//			1	: 	Yep, It's in (What a hero!)
//			0	:	Another Loser!
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
int IsHighScore(DWORD SCORE)
{
	if (SCORE >= HighScores[9].SCORE) return (int) 1; else return (int) 0;
}
